;$C800-tile#40
;make sprites zero
plasma_tilebmp0_page equ $10
plasma_tilemap_page1 equ $11
plasma_tilemap_page2 equ $12

CONNECT_RIGHT=1
CONNECT_DOWN=2
CONNECT_LEFT=4
CONNECT_UP=8


board equ $4000
	device zxspectrum128
        ORG #6000
begin
 include "TSPor.inc"
 
;picture on title
 ld sp,$5FE0
 ld bc,TSConfig
 xor a
 out (c),a
 ld bc, $0faf
 out (c),a

 LD  BC,VPage
 LD  A,#20
 OUT (C),A

 LD  BC,VConfig
 LD  A,%01000010;VID_360X288+256C
 OUT (C),A

;FMAddr     EQU #15AF
 ld bc, FMAddr
 ld a, %00010000
 out (c), a
;load CRAM
 ld de,0
 ld hl,logopal_b
 ld bc,logopal_e-logopal_b
 ldir
;close FMAddr
 ld bc, 0x15AF
 xor a
 out (c), a

 di
 ld a,$5F,i,a
 ld hl,intvec,($5FFF),hl
 im 2
 ei
 call wk
; ld a,1,bc,Page3:out (c),a
;hh:ei:halt
; call channel_unpack
; xor a:in a,($FE):cpl:and 31:jr z,hh
;-----------------------------------------------------
;depack
 ld hl,plasm_fnt,de,$4000:call dzx7_standard
 
;PalSel = %00 //   0   0
 ld bc,PalSel
 xor a
 out (c),a
;----------------------------------------------------------------------------
	xor a;ld	hl,0
	ld	bc,T0XOffsL
	out	(c),a
	inc b;ld	bc,T0XOffsH
	out	(c),a
	inc b;ld	bc,T0YOffsL
	out	(c),a
	inc b;ld	bc,T0YOffsH
	out	(c),a
	inc b;ld	bc,T1XOffsL
	out	(c),a
	inc b;ld	bc,T1XOffsH
	out	(c),a
	inc b;ld	bc,T1YOffsL
	out	(c),a
	inc b;ld	bc,T1YOffsH
	out	(c),a

; MAP tile
 ld a,plasma_tilemap_page2;$12
 call clear_page_dma
 ld bc,TMPage
 out (c),a



 ld a,plasma_tilebmp0_page;$10
 call clear_page_dma
 ld bc,T0GPage;//    0   $10
 out (c),a
 ld bc,T1GPage
 out (c),a
 

VID_16C         equ $01
VID_256C        equ $02
VID_360X288     equ $C0
PLANE0_MODE		equ VID_256C
RASTER_SIZE		equ VID_360X288
VID_NOGFX       equ $20

TSU_T0ZEN		equ $04
TSU_T1ZEN		equ $08
TSU_T0EN		equ $20
TSU_T1EN		equ $40
TSU_SEN			equ $80


 LD	BC,VConfig
 LD	A,VID_NOGFX | VID_360X288
 OUT	(C),A

 ld bc,TSConfig
 ld a,TSU_T0EN | TSU_T0ZEN;%01101100;TSU_T0EN | TSU_T1EN | TSU_T0ZEN | TSU_T1ZEN;%01101100
 ld a,TSU_T0EN | TSU_T1EN | TSU_T0ZEN | TSU_T1ZEN
 out (c),a

;-------generate tile
 call convert_font

n=0
tcol=$AAAA;;3333

 rept 8

 ld hl,tcol,($C800+n*256),hl,($C802+n*256),hl;,($C804+n*256),hl,($C806+n*256),hl
n=n+1
tcol=tcol-$1111

endr

; ld hl,$0202,($C804),hl;$41
 ld hl,digits_b,de,$C804+8
 ld a,8
dlp:
 push de
 ld bc,digits_e1-digits_b:ldir
 pop de
 inc d
 dec a:jr nz,dlp

 ld bc, FMAddr
 ld a, %00010000;$18;;%00010000
 out (c), a
;load CRAM
 ld de,0;$8000
 ld hl,plasm_pal_b
 ld bc,plasm_pal_e-plasm_pal_b
 ldir
;close FMAddr
 ld bc, FMAddr
 xor a
 out (c), a


 ld a,plasma_tilemap_page2
 ld bc,TMPage
 out (c),a
 ld bc,Page3
 out (c),a

;;--test draw tile
;;; ld ix,$C000,b,0
;;;lp:
;;; ld a,b
;;; add a,a
;;; add a,a
;;; ld (ix+0),a
;;; inc a
;;; ld (ix+2),a
;;; inc a
;;; inc ixh
;;; ld (ix+0),a
;;; inc a
;;; ld (ix+2),a
;;; dec ixh
;;; inc ix,ix,ix,ix
;;; inc b
;;; bit 5,b
;;; jr z,lp
; jr $

;; jr $
;; ld hl,zx7,de,zx7+1,bc,end-zx7,(hl),0:ldir
;------------------------------game---------------------------------------------
gameon:

 ld a,plasma_tilemap_page2
 ei:halt
 call clear_page_dma
 
;---------------------------------------------------game on--------------------------------------------------------
;#define  BOARD_ADDR  32484
;#define  BOARD(r,c)  (BOARD_ADDR+((c)<<4)+(r))
;    DO
;        'Play all levels
;        FOR level = 0 TO 9999
play_levels:
;            'Set randomize seed to ensure fixed layout for each level
;            RANDOMIZE (level*5+1111)
 ld hl,(level)
 ld de,hl
 add hl,hl
 add hl,hl
 add hl,de;*5
 ld de,1111
 add hl,de
 ld (SEED), hl
 ld hl,0
 ld (SEED+2),hl;,  
;            'Calculate playing board size depending on current level
;            LET height = ((level+1)>>2)+2
 	ld hl, (level)
	inc hl
	srl h
	rr l
	srl h
	rr l
	inc hl
	inc hl
	ld a, l
	ld (height), a
;IF height>12 THEN height = 12: END IF
	ld a, 12
	ld hl, (height - 1)
	cp h
	jr nc, endif1
	ld a, 12
	ld (height), a
endif1:

;LET width = ((level+3)>>2)+2
	ld hl, (level)
	inc hl
	inc hl
	inc hl
	srl h
	rr l
	srl h
	rr l
	inc hl
	inc hl
	ld a, l
	ld (width), a

;IF width>16 THEN width = 16: END IF
	ld a, 16-1
	ld hl, (width - 1)
	cp h
	jp nc, endif2
	ld a, 16-1
	ld (width), a
endif2:


;'Calculate playing board position on screen
;LET row0 = 12-height
 ld a,(height)
 ld l,a
; neg
; add a,12
 ld a,12:sub l
 ld (row0),a

;LET col0 = 14-width
 ld a,(width)
 ld l,a
 ld a,15:sub l
; neg
; add a,12
 ld (col0),a

gen_loop:
;DO

;'Clear playing board
;FOR i = 0 TO 283: POKE BOARD_ADDR+i,0: NEXT i
 ld hl,board,de,hl,bc,283,(hl),0:inc de:ldir


;'Put tiles on playing board
;FOR row = 0 TO height-1
 ld ixh,0
row_lp1:

;FOR col = width TO 1 STEP -1
 ld a,(width),ixl,a ;;;;;ixl=col,ixh=row
col_lp1:
 
;IF row<>0 OR col<>width THEN
;;	ld a, ixh;(_row)
;;	push af

	ld a,(width),h,a;ld hl, (_width - 1)
	ld a, ixl;(_col)
	sub h
;;	ld h, a
;;	pop af
;;	or h
	or ixh
	or a
	jp z, endif3

;LET b = INT (RND * 256)
 call RANDOM
 ld a,h

 ld b,a

;LET tile = ((PEEK BOARD(row, col+1) & CONNECT_LEFT) >> 2) | ((PEEK BOARD(row-1,col) & CONNECT_DOWN) << 2)
;#define  BOARD(r,c)  (BOARD_ADDR+((c)<<4)+(r))
 ld a,ixl
 inc a;col+1
 ld h,0,l,a
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl;<<4
 ld de,board
 add hl,de
 ld d,0,e,ixh;row
 add hl,de
 ld  a,(hl)
 and CONNECT_LEFT
 srl a
 srl a;>>2
 ld c,a
;(PEEK BOARD(row-1,col)
 ld a,ixl;col
 ld h,0,l,a
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl;<<4
 ld de,board
 add hl,de
 ld d,0,e,ixh
 dec e
 add hl,de
 ld  a,(hl)
 and CONNECT_DOWN
 add a,a
 add a,a;<<2
 or c
 ld c,a

;IF row <> height-1 THEN LET tile = tile | (b & CONNECT_DOWN) : END IF
 ld a,(height)
 dec a
 cp ixh;;row
 jp z,endif4
 
 ld a,b
 and CONNECT_DOWN
 or c
 ld c,a
endif4:

;IF col <> 1 THEN LET tile = tile | (b & CONNECT_LEFT) : END IF
 ld a,ixl;col
 cp 1
 jp z,endif5
 ld a,b
 and CONNECT_LEFT
 or c
 ld c,a
endif5:

;IF b > 191 OR (b > 63 AND (row = 0 OR col = width)) OR tile = 0 THEN
; ld a,c;OR tile = 0
; or a:jp z,if_6
; ld a,b
; cp 191;b > 191
; jp c,if_6
;
;;OR (b > 63 AND (row = 0 OR col = width))
; ld a,b
; cp 63
; jp nc,endif6;AND (row = 0 OR col = width) skipped
;if_6:

;b = b >> 2
 srl b
 srl b

;IF row <> height-1 THEN LET tile = tile | (b & CONNECT_DOWN) : END IF
 ld a,(height)
 dec a
 cp ixh
 jr z,endif7
 ld a,b
 and CONNECT_DOWN
 or c
 ld c,a;,(tile),a
endif7:

;IF col <> 1 THEN LET tile = tile | (b & CONNECT_LEFT) : END IF
 ld a,ixl
 cp 1:jr z,endif8
 ld a,b
 and CONNECT_LEFT
 or c
 ld c,a;,(tile),a

endif8:
;                            END IF
endif6:
;                            POKE BOARD(row, col), tile
 ld a,ixl
 ld h,0,l,a
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl;<<4
 ld de,board
 add hl,de
 ld d,0,e,ixh
 add hl,de
; ld a,ixh,c,a
 ld (hl),c
;                        END IF
endif3:
;                    NEXT col
 dec ixl
 ld a,ixl:cp 1:jp nc, col_lp1
;                NEXT row
 inc ixh
 ld a,(height):dec a:cp ixh:jp nc, row_lp1
 
; jr $
;; call drawtiles
;; ei:halt
;; call wk

;'Rotate tiles, counting total number of open connections on board
;                LET counter = 0
 ld hl,0,(counter),hl
;                FOR row = 0 TO height-1
 ld ixh,0
row_lp3:
 ld a,(width)
 ld ixl,a
;                    FOR col = width TO 1 STEP -1
col_lp3:
;                        LET counter = counter - openConnections(row, col)
 call openConnections
 ld hl,(counter),e,a,d,0
 or a:sbc hl,de
 ld (counter),hl
;                        LET tile = PEEK BOARD(row, col)
;(BOARD_ADDR+((c)<<4)+(r))
 ld a,ixl
 ld h,0,l,a
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl;<<4
 ld de,board
 add hl,de
 ld d,0,e,ixh
 add hl,de
 ld  a,(hl)
 push hl,af
 call RANDOM
 ld a,l
 and 3
 inc a
 ld b,a
 
 pop af;tile
;                        FOR b = 1 TO INT(RND*4)
loop_b:
;                            LET tile = ((tile << 1) & 15) | (tile >> 3)
 ld c,a
 add a,a
 and 15
 srl c
 srl c
 srl c
 or c
;                        NEXT b
 djnz loop_b
;                        POKE BOARD(row, col), tile
 pop hl
 ld (hl),a
;                        LET counter = counter + openConnections(row, col)

 ;jr $
 call openConnections
 ld hl,(counter),e,a,d,0
 add hl,de
 ld (counter),hl
;                    NEXT col
 dec ixl
 ld a,ixl:cp 1:jp nc, col_lp3

;                NEXT row
 inc ixh
 ld a,(height):dec a:cp ixh:jp nc, row_lp3

;'If algorithm generated an already solved board, then re-generate it
;LOOP UNTIL counter <> 0
;- call drawtiles

; ei:halt
; jp gen_loop

 ld hl,(counter)
 ld a,h:or l:jp z,gen_loop

 call drawtiles
;------------------------------------------------------------------------------------------------------
c_pos:ld hl,0,(cursp+2),hl
 
 ;set 7,l:ld (hl),$41:inc l,l:ld (hl),$42

 ld hl,(level):call DispHL
 
 
 ld a,plasma_tilebmp0_page
 ei:halt
 ld bc,Page3:out (c),a


; ld hl,($C804+8),($C804),hl
 ld a,(asciip)
 ld de,$C804+8
 ld bc, $C804
 call outnum

 ld a,(asciip+1)
 ld de,$C804+8+2
 ld bc, $C804+2
 call outnum

 ld a,(asciip+2)
 ld de,$C804+8
 ld bc, $C804+4
 call outnum

 ld a,(asciip+3)
 ld de,$C804+8+2
 ld bc, $C804+4+2
 call outnum

 ld a,plasma_tilemap_page2
 ei:halt
 ld bc,Page3:out (c),a

 ld a,64:call cursor
 
 ld d,0,a,(width),e,a


glp:
 ei:halt
 call wk
; ei
; halt:halt
; halt:halt
; halt:halt
;; halt:halt
; di
 call pageup
;Read controls
 ld a,$F7:in a,($FE):and $10:jp z,left;5
 ld a,$EF:in a,($FE):and $04:jp z,right;8
 
 ld a,$EF:in a,($FE):and $10:jp z,down;7
 ld a,$EF:in a,($FE):and $08:jp z,up;6
 nop:nop
 ld a,$BF:in a,($FE):and $01:jp z,fire
 jp glp

;'Move cursor

;IF (b & JOY_UP)    AND row>0        THEN LET row2 = row2-1: END IF

up:
 ld a,d:or a:jp z,glp
 xor a:call cursor
 dec d
 ld hl,(cursp+2)
 dec h,h
 
 jp last
 
 ld (cursp+2),hl
 ld a,64:call cursor
 jp glp

;IF (b & JOY_DOWN)  AND row<height-1 THEN LET row2 = row2+1: END IF
down:
 ld a,(height)
 dec a
 cp d:jp z,glp
 xor a:call cursor
 inc d
 ld hl,(cursp+2)
 inc h,h
 
 jp last
 
 ld (cursp+2),hl
 ld a,64:call cursor
 jp glp

;IF (b & JOY_LEFT)  AND col>1        THEN LET col2 = col2-1: END IF
left:
 ld a,e:cp 1:jp z,glp
 xor a:call cursor
 dec e

 ld hl,(cursp+2)
 dec hl,hl,hl,hl
 
 jp last
 
 ld (cursp+2),hl
 ld a,64:call cursor
 jp glp

;IF (b & JOY_RIGHT) AND col<width    THEN LET col2 = col2+1: END IF
right:
 ld a,(width)
 cp e:jp z,glp
 xor a:call cursor
 inc e
 ld hl,(cursp+2)
 inc hl,hl,hl,hl
last:
 ld (cursp+2),hl
 ei:halt
 ld a,64:call cursor
nwk:xor a:in a,($FE):cpl:and 31:jr nz,nwk
 jp glp

fire:
;'Rotate tile
;LET counter = counter - openConnections(row, col)
 push de
 push de;D=row,E=col
 pop ix
 call openConnections;ixh=row,ixl=col
 ld e,a,d,0
 ld hl,(counter)
 or a:sbc hl,de
 ld (counter),hl
 pop de

;LET tile = PEEK BOARD(row,col),BOARD_ADDR+((c)<<4)+(r))
 push de;D=row,E=col
 ld h,0,l,e;c
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl;<<4
 ld bc,board
 add hl,bc
 ld b,0,c,d;r
 add hl,bc
 ld a,(hl)

 ld c,a

;POKE BOARD(row,col), ((tile << 1) & 15) | (tile >> 3)

 add a,a
 and 15
 srl c
 srl c
 srl c
 or c
 ld (hl),a
 call drawtiles
; ei:halt
 pop de
 push de
 push de;D=row,E=col
 pop ix
 call openConnections;ixh=row,ixl=col
 ld e,a,d,0
 ld hl,(counter)
 add hl,de
 ld (counter),hl
 pop de
 
;LET counter = counter + openConnections(row, col)
;END IF
;'If cursor moved or rotated, redraw last cursor position
;IF (b & JOY_FIRE) OR row2<>row OR col2<>col THEN
; drawTile(row, col, 4)
;END IF
 ei:halt
n_wk:xor a:in a,($FE):cpl:and 31:jr nz,n_wk
 ld hl,(counter)
 ld a,h:or l
 jp nz,glp

;'Repeat until level is solved
;LOOP UNTIL counter=0
next_lev:
 xor a:call cursor

; End level effect
;Play next level
;NEXT level
 ld hl,(level)
 inc hl
 ld (level),hl
 ld de,9999
 or a
 sbc hl,de
 jp nz,gameon;play_levels

xyj:ld a,r:out ($FE),a:jr xyj
;        ' End last level effect
;        pauseFrames(100): FOR b = 0 TO 6: paintScreen(6-b): pauseFrames(10): NEXT b
;    LOOP

pageup:
 ld a,$FB:in a,($FE)
 bit 0,a:ret nz;Q
 ld bc,1000:bit 1,a:jp z,add_lev;W
 ld bc,100:bit 2,a:jp z,add_lev;E
 ld bc,10:bit 3,a:jp z,add_lev;R
 ld bc,1:bit 4,a:jp z,add_lev;T
 ret
add_lev:
 ld hl,(level)
 or a:add hl,bc
 ;ret c
wwk:ld a,$FB:in a,($FE)
 and %00011110:cp %00011110:jr nz,wwk
 ld (level),hl
 pop af
 xor a:call cursor
 jp gameon
;------------------------------------------------------------------------------------------------------
outnum:
;A=digit
;DE-tileadr
;BC=where to put
 ld l,a,h,0
 add hl,hl
 add hl,hl
; ld de,$C804+8
 add hl,de


 push bc
 pop de
 ;ld de,$C804
 ld a,8
putd:
 push hl,de
 ldi:ldi
 pop de,hl
 inc h,d
 dec a:jr nz, putd
 ret
;------------------------------
cursor:

cursp:ld ix,$5800
 ld (ix+0),a
 ld (ix+1),0
 ld (ix+2),a
 ld (ix+3),0
 inc ixh

 ld (ix+0),a
 ld (ix+1),$80
 ld (ix+2),a
 ld (ix+3),$80

 ret
wk:xor a:in a,($FE):cpl:and 31:jr z,wk:ret
openConnections:;ixh=row,ixl=col
;function openConnections(row AS UBYTE, col AS UBYTE) AS UINTEGER
;    DIM tile AS UBYTE
;    DIM n AS UINTEGER
;    LET n = 0
 ld c,0
;    LET tile = PEEK BOARD(row, col)
 call peek
 ld b,a;B=tile
 push ix
; push hl
; pop ix
;    IF (tile & CONNECT_DOWN)  AND NOT (PEEK BOARD(row+1, col) & CONNECT_UP)    THEN LET n = n+1: END IF
 ld a,b:and CONNECT_DOWN:jr z,oc_if1
 inc ixh:call peek:dec ixh
 ;;ld a,(ix+16)
 and CONNECT_UP:jr nz,oc_if1
 inc c
oc_if1:
;    IF (tile & CONNECT_UP)    AND NOT (PEEK BOARD(row-1, col) & CONNECT_DOWN)  THEN LET n = n+1: END IF
 ld a,b:and CONNECT_UP:jr z,oc_if2
 dec ixh:call peek:inc ixh
 ;;ld a,(ix-16)
 and CONNECT_DOWN:jr nz,oc_if2
 inc c
oc_if2:
;    IF (tile & CONNECT_LEFT)  AND NOT (PEEK BOARD(row, col-1) & CONNECT_RIGHT) THEN LET n = n+1: END IF
 ld a,b:and CONNECT_LEFT:jr z,oc_if3
 
 dec ixl:call peek:inc ixl
 ;;ld a,(ix-1)
 and CONNECT_RIGHT:jr nz,oc_if3
 inc c
oc_if3:
;    IF (tile & CONNECT_RIGHT) AND NOT (PEEK BOARD(row, col+1) & CONNECT_LEFT)  THEN LET n = n+1: END IF
 ld a,b:and CONNECT_RIGHT:jr z,oc_if4
 inc ixl:call peek:dec ixl
 ;;ld a,(ix+1)
 and CONNECT_LEFT:jr nz,oc_if4
 inc c
oc_if4:
 pop ix
 ld a,c
;    RETURN n
;end function
 ret

peek:
 ld a,ixl
 ld h,0,l,a
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl;<<4
 ld de,board
 add hl,de
 ld d,0,e,ixh
 add hl,de
 ld a,(hl)
 ret
 
RANDOM:     LD HL,(SEED+2)
            LD D,L
            ADD HL,HL
            ADD HL,HL
            LD C,H
            LD HL,(SEED)
            LD B,H
            RL B
            LD E,H
            RL E
            RL D
            ADD HL,BC
            LD (SEED),HL
            LD HL,(SEED+2)
            ADC HL,DE
            RES 7,H
            LD (SEED+2),HL
            JP M,RANDOM3
            LD HL,SEED
RANDOM2:    INC (HL)
            INC HL
            JR Z,RANDOM2
RANDOM3:    LD HL,(SEED)
 ret
SEED: dw $E5,0


drawtiles:

;FOR row = 0 TO height-1
 ld ixh,0;;;;;ixl=col,ixh=row
row_lp2:
;FOR col = width TO 1 STEP -1
 ld a,(width),ixl,a

col_lp2:
;LET tile = PEEK BOARD(row, col),BOARD(r,c)  (BOARD_ADDR+((c)<<4)+(r))
;-LET ch = (tile<<2)+32

 ld a,ixl
 ld h,0,l,a
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl;<<4
 ld de,board
 add hl,de
 ld d,0,e,ixh
 add hl,de

; jr $
 ld a,(hl)
 push ix
 
 add a,a
 add a,a;<<2
 push af

 ld a,(row0)
 ld d,a
 ld a,ixh
 add a,a;*2
 add a,d
 ld d,a


 ld a,(col0)
 ld e,a
 ld a,ixl
 add a,a
 add a,e
 ld e,a

;D=y,E=X
 ld h,0
 ld l,e
 add hl,hl
 ld a,h
 add a,d
 add a,$C0
 ld h,a

 set 7,l
 push hl
 pop ix
 
 pop af
 ld (ix+0),a
 inc a
 ld (ix+2),a
 inc a
 inc ixh
 ld (ix+0),a
 inc a
 ld (ix+2),a
 
 pop ix

; LET tile = PEEK BOARD(row, col)
; get adr
 ld a,ixh:or a:jr nz,drawti
 ld a,(width):cp ixl:jr nz,drawti
 ld (hl),$41:inc l,l:ld (hl),$42:dec l,l
 res 7,l
 ld (c_pos+1),hl;;;ld (hl),64
; push ix
; call draw_l_n
; pop ix
; jr next_col
;PRINT AT row0+(row<<1), col0+(col<<1)
drawti:
; call dt_lp:;HL=addres,DE=tiles
; pop hl
 ;to next tile
;next col
next_col:
; ei:halt
 dec ixl
 ld a,ixl
 cp 1
 jp nc,col_lp2
 
;;- jr $
; ld a,$C9,(save),a
; pop hl
; ld a,l:add a,$40:ld l,a
; jr nc,no_next
; ld a,h:add a,8:ld h,a
;no_next:
;next row
 inc ixh
 ld a, (height)
 dec a
 cp ixh
 jp nc, row_lp2

; call draw_l_n
 ret

;save:nop
; ld (sta+1),hl
; ret
;dt_lp:;HL=addres,DE=tiles
;
; call drawp
; inc l:call drawp
; 
; push hl
; ld a,l:add a,31:ld l,a:jr nc,adzip
; ld a,h:add a,8:ld h,a
;adzip:
; call drawp
; inc l:call drawp
; pop hl
; ret
;
;drawp:
;; ei:halt
; push hl
; ld b,8
;drlp:
; ld a,(de),(hl),a:inc h,de:djnz drlp
; pop hl
; ret

;--------------------------------------------------
; Get screen address
; D = Y character position
; E = X character position
; Returns address in DE
; Title:    ZX Spectrum Standard Output Routines
; Author:   Dean Belfield
; Created:  29/07/2011
; Last Updated: 02/07/2012
;;Get_Char_Address:   LD A,D
;;	            AND %00000111
;;	            RRA
;;	            RRA
;;	            RRA
;;	            RRA
;;	            OR E
;;	            LD E,A
;;	            LD A,D
;;	            AND %00011000
;;	            OR $40
;;	            LD D,A
;; ret

;Decimal Unsigned Versions

;First a simple and small to show. Mostly for debugging or simple programs.
;Number in hl to decimal ASCII
;Thanks to z80 Bits
;inputs:	hl = number to ASCII
;example: hl=300 outputs '00300'
;destroys: af, bc, hl, de used
DispHL:
	ld ix,asciip
;	ld	bc,-10000
;	call	Num1
	ld	bc,-1000
	call	Num1
	ld	bc,-100
	call	Num1
	ld	c,-10
	call	Num1
	ld	c,-1
Num1:	ld	a,-1
Num2:	inc	a
	add	hl,bc
	jr	c,Num2
	sbc	hl,bc
	ld (ix+0),a:inc ix;call PUTCHAR
	ret
asciip: db 0,0,0,0,0
;digits:
; db %00000111;0
; db %00000101
; db %00000101
; db %00000101
; db %00000111
; 
; db %00000010;1
; db %00000110
; db %00000010
; db %00000010
; db %00000010
;
; db %00000111;2
; db %00000001
; db %00000010
; db %00000100
; db %00000111
;
; db %00000111;3
; db %00000001
; db %00000010
; db %00000001
; db %00000111
;
; db %00000101;4
; db %00000101
; db %00000111
; db %00000001
; db %00000001
;
; db %00000111;5
; db %00000100
; db %00000111
; db %00000001
; db %00000111
;
; db %00000100;6
; db %00000100
; db %00000111
; db %00000101
; db %00000111
;
; db %00000111;7
; db %00000001
; db %00000001
; db %00000001
; db %00000001
;
; db %00000111;8
; db %00000101
; db %00000111
; db %00000101
; db %00000111
;
; db %00000111;9
; db %00000101
; db %00000111
; db %00000001
; db %00000001

;--------------------------------------------------
intvec:
;; ei:ret
 push ix,iy
 push af,bc,de,hl
 exx:exa
 push af,bc,de,hl
 ld bc,Page3
 in a,(c)
 push af
 ld a,1:out (c),a
 call channel_unpack
 pop af
 ld bc,Page3:out (c),a
 pop hl,de,bc,af
 exx:exa
 pop hl,de,bc,af
 pop iy,ix
 ei:ret
;--------------------------------------------------
level dw 0;11;9999
counter: dw 0
height: db 0
width: db 0
row0: db 0
col0: db 0
;--------------------------------------------------------------------------------
convert_font:
 ld hl,bits,de,#5800,bc,4:ldir

 ld hl,$4000
 ld de,$C000
ch2:
 ld ixl,8
 push de
ch1:
 push de
 dup 4
 xor a
 rl (hl):adc a,0:add a,a
 rl (hl):adc a,0
 ld c,a,b,$58
 ld a,(bc),(de),a:inc e
edup
 pop de
 inc d
 inc hl
 dec ixl:jr nz,ch1
 pop de
 ld a,e:add a,4:ld e,a:jr nz,none1
 ld a,d:add a,8:ld d,a
none1:
 ld a,d:cp $E0
 jp nz,ch2
 ret
clr0 equ 0;for font - back color
clr1 equ 1
bits: db clr0*17,clr0*16+clr1,clr1*16+clr0,clr1*17





clear_page_dma:
 ei:halt
 push af
 ld bc,Page3
 out (c),a
 ld hl,0
 ld (#c000),hl
 ld bc,#1AAF
 ld hl,$C000
 out (c),l;DMASAddrL    EQU	#1AAF
 inc b
 out (c),h;l;DMASAddrH    EQU	#1BAF
 inc b
 out (c),a;h;DMASAddrX    EQU	#1CAF
 inc b
;TSL:;2.  DMADAddrL   2,     8194 ,  2 ,  .  Fill  Src  Dest  
 ld l,2
 out (c),l;DMADAddrL    EQU	#1DAF
 inc b
 out (c),h;l;DMADAddrH    EQU	#1EAF
 inc b
 out (c),a;h;DMADAddrX    EQU	#1FAF
 ld l,255
 ld b,#26

;		defb #28,200	;
;		defb #26,#ff	;
;		defb #27,%00000100    ; DMA_FILL

 out (c),l;DMALen    EQU	#26AF
 inc b
 inc b
 ld a,31;15+2;(15+1)*2=32, 32*512=16384
 out (c),a;;l;DMANum    EQU	#28AF
 dec b
 ld a,%00000100; FILL->RAM
 out (c),a;DMACtrl   EQU	#27AF
waitdma1:
 inf
 jp m,waitdma1
 pop af
 ret
;----------------------------------------------------

plasm_pal_b:
 dw 1024*0+32*0+31*0;R.G.B-0
 dw 1024*31+32*31+31;R.G.B-1
 dw 1024*0+32*31;+31;R.G.B-2------for font

; dw 1024*31*0+0*32*31+31;R.G.B-3
n=31
 rept 8
 dw n;-3
n=n-4
endr

plasm_pal_e:

logopal_b:
 incbin "picpal.bin"
logopal_e:
;board:

zx7:include "zx7.a80"
plasm_fnt:incbin "zen.chr.zx7";"plsm.fnt.zx7"

digits_b:
 db $002,$022,$002,$022,$000,$020,$000,$020,$002,$022,$002,$022,$002,$022,$002,$022,$002,$002,$002,$002,$002,$022,$002,$022,$002,$000,$002,$000,$002,$022,$002,$022,$002,$022,$002,$022,$002,$022,$002,$022
digits_e1:
 db $002,$002,$002,$002,$002,$020,$002,$020,$000,$002,$000,$002,$000,$002,$000,$002,$002,$002,$002,$002,$002,$000,$002,$000,$002,$000,$002,$000,$000,$002,$000,$002,$002,$002,$002,$002,$002,$002,$002,$002
 db $002,$002,$002,$002,$000,$020,$000,$020,$000,$002,$000,$002,$000,$002,$000,$002,$002,$002,$002,$002,$002,$000,$002,$000,$002,$000,$002,$000,$000,$002,$000,$002,$002,$002,$002,$002,$002,$002,$002,$002
 db $002,$002,$002,$002,$000,$020,$000,$020,$002,$022,$002,$022,$002,$020,$002,$020,$002,$022,$002,$022,$002,$022,$002,$022,$002,$022,$002,$022,$000,$002,$000,$002,$002,$022,$002,$022,$002,$002,$002,$002
 db $002,$002,$002,$002,$000,$020,$000,$020,$002,$000,$002,$000,$000,$002,$000,$002,$000,$002,$000,$002,$000,$002,$000,$002,$002,$002,$002,$002,$000,$002,$000,$002,$002,$002,$002,$002,$002,$022,$002,$022
 db $002,$002,$002,$002,$000,$020,$000,$020,$002,$000,$002,$000,$000,$002,$000,$002,$000,$002,$000,$002,$000,$002,$000,$002,$002,$002,$002,$002,$000,$002,$000,$002,$002,$002,$002,$002,$000,$002,$000,$002
 db $002,$002,$002,$002,$000,$020,$000,$020,$002,$000,$002,$000,$000,$002,$000,$002,$000,$002,$000,$002,$000,$002,$000,$002,$002,$002,$002,$002,$000,$002,$000,$002,$002,$002,$002,$002,$000,$002,$000,$002
 db $002,$022,$002,$022,$000,$020,$000,$020,$002,$022,$002,$022,$002,$022,$002,$022,$000,$002,$000,$002,$002,$022,$002,$022,$002,$022,$002,$022,$000,$002,$000,$002,$002,$022,$002,$022,$002,$022,$002,$022

digits_e:
end

;------------------------------music------------------------------------
 page 1
        macro ChanStruct state,pkd_stream,win_addr,win_mask,cntr,win_rep
        db state
        dw pkd_stream
        dw win_addr
        dw win_mask
        db cntr
        dw win_rep
        endm


        org #c000
page1b:
        ds 512*14		; channel buffers! do not move!

; play routine
channel_unpack
	ld ix,channels
	ld de,ay_regs
        ld b,14
loop1   push bc

	ld l,(ix+1),h,(ix+2)	; packed stream addr
	ld a,(ix+0)
	or a:jp z,unpack_getnew
	dec a:jp z,unpack_rep
	jp unpack_copy


loop1r
	ld bc,10:add ix,bc
        pop bc
        djnz loop1
	call play_regs
        ret
;--------extra new data------------------
ch_b
	ChanStruct 0,stream0,#c000,#01c0,0,#0000
	ChanStruct 0,stream1,#c200,#01c2,0,#0000
	ChanStruct 0,stream2,#c400,#01c4,0,#0000
	ChanStruct 0,stream3,#c600,#01c6,0,#0000
	ChanStruct 0,stream4,#c800,#01c8,0,#0000
	ChanStruct 0,stream5,#ca00,#01ca,0,#0000
	ChanStruct 0,stream6,#cc00,#01cc,0,#0000
	ChanStruct 0,stream7,#ce00,#01ce,0,#0000
	ChanStruct 0,stream8,#d000,#01d0,0,#0000
	ChanStruct 0,stream9,#d200,#01d2,0,#0000
	ChanStruct 0,streama,#d400,#01d4,0,#0000
	ChanStruct 0,streamb,#d600,#01d6,0,#0000
	ChanStruct 0,streamc,#d800,#01d8,0,#0000
	ChanStruct 0,streamd,#da00,#01da,0,#0000
ch_e
; -----------------------------------------------------------------------------
re_new
 ld hl,ch_b
 ld de,channels
 ld bc,ch_e-ch_b
 ldir
; ld a,4:out ($FE),a
 pop af;
 ret

unpack_getnew
; 	ld l,(ix+1),h,(ix+2)	; packed stream addr
	ld a,(hl):inc hl
	cp #81:jr z,re_new
	or a:jp m,new_rep	; bit7=0, rep. blk

	; copy as is
	ld (ix+7),a
	ld (ix+0),2		; next entry - unpack_copy

unpack_copy
	ld a,(hl):ldi		; copy to ay_regs
	ld (ix+1),l,(ix+2),h	; packed stream addr

	ld l,(ix+3),h,(ix+4)	; window addr
	ld (hl),a:inc hl
	ld c,(ix+5),b,(ix+6)	; window addr mask
	ld a,h:and b:or c:ld h,a
	ld (ix+3),l,(ix+4),h	; window addr

	dec (ix+7)
	jp nz,loop1r
	ld (ix+0),0		; next entry - unpack_getnew
	jp loop1r


new_rep
	ld b,a
	ld c,(hl):inc hl
	ld a,(hl):inc hl
	ld (ix+7),a
	ld (ix+0),1		; next entry - unpack_rep
	ld (ix+1),l,(ix+2),h	; packed stream addr
	ld l,(ix+3),h,(ix+4)	; window addr
	add hl,bc
	ld c,(ix+5),b,(ix+6)	; window addr mask
	ld a,h:and b:or c:ld h,a
	ld (ix+8),l,(ix+9),h	; win rep addr

unpack_rep
	ld l,(ix+8),h,(ix+9)	; win rep addr
	ld a,(hl):ldi ; copy to ay_regs
	exa
	ld c,(ix+5),b,(ix+6)	; window addr mask
	ld a,h:and b:or c:ld h,a
	exa
	ld (ix+8),l,(ix+9),h	; win rep addr

	ld l,(ix+3),h,(ix+4)	; window addr
	ld (hl),a:inc hl
	ld a,h:and b:or c:ld h,a
	ld (ix+3),l,(ix+4),h	; window addr

	dec (ix+7)
	jp nz,loop1r
	ld (ix+0),0		; next entry - unpack_getnew
	jp loop1r
; -----------------------------------------------------------------------------

play_regs
	xor a
	ld de,#ffbf
	ld bc,#fffd
	ld hl,ay_regs
	dup 13
	out (c),a
	ld b,e:outi:ld b,d
	inc a
	edup

	out (c),a
	ld a,(hl)
	and a:ret m
	ld b,e:out (c),a
	ret
; -----------------------------------------------------------------------------
; channels data
; 512b  win and mask = #01
; 1024b win and mask = #03
; 2048b win and mask = #07
channels
	ChanStruct 0,stream0,#c000,#01c0,0,#0000
	ChanStruct 0,stream1,#c200,#01c2,0,#0000
	ChanStruct 0,stream2,#c400,#01c4,0,#0000
	ChanStruct 0,stream3,#c600,#01c6,0,#0000
	ChanStruct 0,stream4,#c800,#01c8,0,#0000
	ChanStruct 0,stream5,#ca00,#01ca,0,#0000
	ChanStruct 0,stream6,#cc00,#01cc,0,#0000
	ChanStruct 0,stream7,#ce00,#01ce,0,#0000
	ChanStruct 0,stream8,#d000,#01d0,0,#0000
	ChanStruct 0,stream9,#d200,#01d2,0,#0000
	ChanStruct 0,streama,#d400,#01d4,0,#0000
	ChanStruct 0,streamb,#d600,#01d6,0,#0000
	ChanStruct 0,streamc,#d800,#01d8,0,#0000
	ChanStruct 0,streamd,#da00,#01da,0,#0000


	align 16
ay_regs	ds 14

packed_data
stream0	incbin "aydump\stream_00"
 db $81
stream1	incbin "aydump\stream_01"
 db $81
stream2	incbin "aydump\stream_02"
 db $81
stream3	incbin "aydump\stream_03"
 db $81
stream4	incbin "aydump\stream_04"
 db $81
stream5	incbin "aydump\stream_05"
 db $81
stream6	incbin "aydump\stream_06"
 db $81
stream7	incbin "aydump\stream_07"
 db $81
stream8	incbin "aydump\stream_08"
 db $81
stream9	incbin "aydump\stream_09"
 db $81
streama	incbin "aydump\stream_0a"
 db $81
streamb	incbin "aydump\stream_0b"
 db $81
streamc	incbin "aydump\stream_0c"
 db $81
streamd	incbin "aydump\stream_0d"
 db $81

page1e:

;-----------------------------------------------------------------------

	display /d,end-begin
	display zx7
	savebin "zenloops.bin",begin,end-begin
	page 1
	savebin "musicp1.bin",page1b,page1e-page1b


